Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ISessionScopeRule.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ISessionScopeRule.java	(revision 1146)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ISessionScopeRule.java	(revision 1146)
@@ -0,0 +1,48 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.tasktrees.temporalrelation;
+
+import java.util.List;
+
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IUserSession;
+
+/**
+ * <p>
+ * A session scope rule is able to detected temporal relationships between task instances of the
+ * sessions provided to the {@link #apply(List<IUserSession>)} method. The rule creates temporal
+ * relationships between the tasks of the task instances, i.e. substructures in the task tree, if
+ * it detects a temporal relationship and instantiates the temporal relationships according to
+ * their occurrences.
+ * </p>
+ * 
+ * @author Patrick Harms
+ */
+interface ISessionScopeRule extends ITemporalRelationshipRule {
+
+    /**
+     * <p>
+     * Applies the rule to the given sessions. The returned rule application result is null, if the
+     * rule can not be applied, i.e. it does not detect a temporal relationship. It returns a rule
+     * application result with a status {@link RuleApplicationStatus#RULE_APPLICATION_FINISHED} if
+     * the rule was applied. The result contains all newly created tasks and task instances.
+     * </p>
+     * 
+     * @param sessions the session on which the rule shall be applied
+     *                    
+     * @return the rule application result as described.
+     */
+    RuleApplicationResult apply(List<IUserSession> sessions);
+
+}
Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ITaskInstanceListScopeRule.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ITaskInstanceListScopeRule.java	(revision 1146)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ITaskInstanceListScopeRule.java	(revision 1146)
@@ -0,0 +1,45 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.tasktrees.temporalrelation;
+
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstanceList;
+
+/**
+ * <p>
+ * a task instance list scope rule is able to detected temporal relationships between a list of task
+ * instances provided to the {@link #apply(ITaskInstanceList)} method. A rule creates temporal
+ * relationships between the task instances, i.e. substructures in the task tree, if
+ * it detects a temporal relationship and instantiates the temporal relationships accordingly.
+ * </p>
+ * 
+ * @author Patrick Harms
+ */
+interface ITaskInstanceListScopeRule extends ITemporalRelationshipRule {
+
+  /**
+   * <p>
+   * applies the rule to the given task instance list. The returned rule application result is null,
+   * if the rule can not be applied, i.e. it does not detect a temporal relationship. It returns a
+   * rule application result with a status {@link RuleApplicationStatus#RULE_APPLICATION_FINISHED}
+   * if the rule was applied. The result contains all newly created parent tasks and task instances.
+   * </p>
+   * 
+   * @param taskInstances the list of task instances to apply the rule on
+   *                    
+   * @return the rule application result as described.
+   */
+  RuleApplicationResult apply(ITaskInstanceList taskInstances);
+  
+}
Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ITemporalRelationshipRule.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ITemporalRelationshipRule.java	(revision 1146)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/ITemporalRelationshipRule.java	(revision 1146)
@@ -0,0 +1,26 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.tasktrees.temporalrelation;
+
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Patrick Harms
+ */
+public interface ITemporalRelationshipRule {
+
+}
Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleApplicationResult.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleApplicationResult.java	(revision 1133)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleApplicationResult.java	(revision 1146)
@@ -18,12 +18,13 @@
 import java.util.List;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTreeNode;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
 
 /**
  * <p>
- * The rule application result describes the result of applying a {@link TemporalRelationshipRule}
- * on a task tree node. It contains a {@link RuleApplicationStatus} and a list of all parent
- * task tree nodes that were created during a rule application. See the description of
- * {@link TemporalRelationshipRule} for more details.
+ * The rule application result describes the result of applying a {@link ITemporalRelationshipRule}.
+ * It contains a {@link RuleApplicationStatus} and a list of all parent task instances and tasks
+ * that were created during a rule application. See the description of
+ * {@link ITemporalRelationshipRule} for more details.
  * </p>
  * 
@@ -36,5 +37,8 @@
 
     /** */
-    private List<ITaskTreeNode> newParents = new ArrayList<ITaskTreeNode>();
+    private List<ITask> newParentTasks = new ArrayList<ITask>();
+
+    /** */
+    private List<ITaskInstance> newParentInstances = new ArrayList<ITaskInstance>();
 
     /**
@@ -67,18 +71,36 @@
     /**
      * <p>
-     * add a further parent node created during the rule application
+     * add a further parent task created during the rule application
      * </p>
      */
-    void addNewlyCreatedParentNode(ITaskTreeNode newParent) {
-        newParents.add(newParent);
+    void addNewlyCreatedTask(ITask newParent) {
+        newParentTasks.add(newParent);
     }
 
     /**
      * <p>
-     * return all parent nodes created during the rule application
+     * return all parent tasks created during the rule application
      * </p>
      */
-    List<ITaskTreeNode> getNewlyCreatedParentNodes() {
-        return newParents;
+    List<ITask> getNewlyCreatedTasks() {
+        return newParentTasks;
+    }
+
+    /**
+     * <p>
+     * add a further parent task instance created during the rule application
+     * </p>
+     */
+    void addNewlyCreatedTaskInstance(ITaskInstance newParent) {
+        newParentInstances.add(newParent);
+    }
+
+    /**
+     * <p>
+     * return all parent task instances created during the rule application
+     * </p>
+     */
+    List<ITaskInstance> getNewlyCreatedTaskInstances() {
+        return newParentInstances;
     }
 
Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleApplicationStatus.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleApplicationStatus.java	(revision 1133)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleApplicationStatus.java	(revision 1146)
@@ -17,6 +17,6 @@
 /**
  * <p>
- * The rule application status describes the result of applying a {@link TemporalRelationshipRule}
- * on a task tree node. See the description of {@link TemporalRelationshipRule} for more details.
+ * The rule application status describes the result of applying a {@link ITemporalRelationshipRule}.
+ * See the description of {@link ITemporalRelationshipRule} for more details.
  * </p>
  * 
@@ -25,4 +25,5 @@
 enum RuleApplicationStatus {
     FINISHED,
+    // TODO drop feasible
     FEASIBLE,
     NOT_APPLIED;
Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleUtils.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleUtils.java	(revision 1133)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/RuleUtils.java	(revision 1146)
@@ -15,8 +15,9 @@
 package de.ugoe.cs.autoquest.tasktrees.temporalrelation;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTreeBuilder;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTreeNode;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTreeNodeFactory;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstanceList;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskFactory;
 
 /**
@@ -35,21 +36,18 @@
      * 
      */
-    static ISequence getSubSequenceInRange(ITaskTreeNode         parent,
-                                           int                   startIndex,
-                                           int                   endIndex,
-                                           String                description,
-                                           ITaskTreeNodeFactory  nodeFactory,
-                                           ITaskTreeBuilder      builder)
+    static ITaskInstance getSubSequenceInRange(ITaskInstanceList parent,
+                                               int               startIndex,
+                                               int               endIndex,
+                                               ITask             model,
+                                               ITaskFactory      taskFactory,
+                                               ITaskBuilder      taskBuilder)
     {
-        ISequence sequence = nodeFactory.createNewSequence();
-        if (description != null) {
-            builder.setDescription(sequence, description);
+        ITaskInstance subsequence = taskFactory.createNewTaskInstance(model);
+
+        for (int i = startIndex; i <= endIndex; i++) {
+            taskBuilder.addChild(subsequence, parent.get(i));
         }
 
-        for (int i = startIndex; i <= endIndex; i++) {
-            builder.addChild(sequence, parent.getChildren().get(i));
-        }
-
-        return sequence;
+        return subsequence;
     }
 
@@ -57,24 +55,22 @@
      * 
      */
-    static ISequence createNewSubSequenceInRange(ITaskTreeNode         parent,
-                                                 int                   startIndex,
-                                                 int                   endIndex,
-                                                 String                description,
-                                                 ITaskTreeNodeFactory  nodeFactory,
-                                                 ITaskTreeBuilder      builder)
+    static ITaskInstance createNewSubSequenceInRange(ITaskInstanceList parent,
+                                                     int               startIndex,
+                                                     int               endIndex,
+                                                     ITask             model,
+                                                     ITaskFactory      taskFactory,
+                                                     ITaskBuilder      taskBuilder)
     {
-        ISequence sequence = nodeFactory.createNewSequence();
-        if (description != null) {
-            builder.setDescription(sequence, description);
+        ITaskInstance subsequence = taskFactory.createNewTaskInstance(model);
+
+        for (int i = startIndex; i <= endIndex; i++) {
+            taskBuilder.addChild(subsequence, parent.get(startIndex));
+            taskBuilder.removeTaskInstance(parent, startIndex);
         }
 
-        for (int i = startIndex; i <= endIndex; i++) {
-            builder.addChild(sequence, parent.getChildren().get(startIndex));
-            builder.removeChild((ISequence) parent, startIndex);
-        }
 
-        builder.addChild((ISequence) parent, startIndex, sequence);
+        taskBuilder.addTaskInstance(parent, startIndex, subsequence);
 
-        return sequence;
+        return subsequence;
     }
 
